         title   Split4

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \MASM32V1\include\Windows.inc
            include  \MASM32V1\include\user32.inc
            include  \MASM32V1\include\kernel32.inc
            include  \MASM32V1\include\gdi32.inc
            include  \MASM32V1\include\comctl32.inc
            include  \MASM32V1\include\comdlg32.inc

;       include  \MASM32V1\include\DSPMACRO.asm

         includelib  \MASM32V1\lib\user32.lib
         includelib  \MASM32V1\lib\kernel32.lib
         includelib  \MASM32V1\lib\gdi32.lib
         includelib  \MASM32V1\lib\comctl32.lib
         includelib  \MASM32V1\lib\comdlg32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SplitBarProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.const
IDM_EXIT       equ 2001

.data
ClassName      db  'Split4',0
AppName        db  'Split4',0
StatClass      db  'msctls_statusbar32',0
StaticClass    db  'STATIC',0
MenuName       db  'MainMenu',0
szNull         db  0

Split1         dd  0, 119, 170, 121
Split2         dd  169, 0, 171, 120
Split3         dd  171, 119, 170, 121
Split4         dd  169, 121, 171, 120
fmat3          db  '%03d',0
szX            db  ' x ',0
szOutW         db  5   dup(?)
szOutH         db  5   dup(?)
szOut          db  20  dup(?)

.data?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hWnd           dd  ?
MenuCnt        dd  ?

hWndStat       dd  ?
hWndChild1     dd  ?
hWndChild2     dd  ?
hWndChild3     dd  ?
hWndChild4     dd  ?
hSplitBar      dd  ?
BarType        dd  ?
hBR            dd  ?
sbParts        dd  4   dup(?)

;---------- [Structures] ----------

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_WINDOW+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 353
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 300
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 353, 311, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc  uses esi edi ebx  hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    xPos:DWORD, yPos, w2, h3, w4

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
            mov     hWndStat, eax

;---------- [Control window] ----------
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr StaticClass, NULL,\
                    WS_BORDER or WS_CHILD or WS_VISIBLE or \
                    SS_SUNKEN,\
                    0, 0, 170, 120, hwnd, 44, hInst, NULL
            mov     hWndChild1, eax
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr StaticClass, NULL,\
                    WS_BORDER or WS_CHILD or WS_VISIBLE or \
                    SS_SUNKEN,\
                    171, 0, 170, 120, hwnd, 44, hInst, NULL
            mov     hWndChild2, eax
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr StaticClass, NULL,\
                    WS_BORDER or WS_CHILD or WS_VISIBLE or \
                    SS_SUNKEN,\
                    0, 121, 170, 120, hwnd, 44, hInst, NULL
            mov     hWndChild3, eax
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr StaticClass, NULL,\
                    WS_BORDER or WS_CHILD or WS_VISIBLE or \
                    SS_SUNKEN,\
                    171, 121, 170, 120, hwnd, 44, hInst, NULL
            mov     hWndChild4, eax

      .elseif wMsg == WM_CTLCOLORSTATIC
         INVOKE     SetBkMode, wParam, TRANSPARENT
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE

;---------- [Size the Statusbar Control] ----------
            mov     eax, lParam       ; Get width
            and     eax, 0ffffh       ; Lowword
            shr     eax, 2            ; /4
            mov     ecx, eax          ; Save factor
            mov     sbParts, eax      ; Make part 1 1/4 the width
            add     eax, ecx
            mov     [sbParts+4], eax  ; and also part2, .. etc
            add     eax, ecx
            mov     [sbParts+8], eax
            mov     [sbParts+12], -1  ; The last part extends to the end
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 4, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE

         INVOKE     GetWindowRect, hWndStat, addr rect ; Rectangle of statusbar
            mov     eax, rect.bottom
            sub     eax, rect.top                      ; eax = height of statusbar
           push     eax
         INVOKE     GetClientRect, hWnd, addr rect
            pop     eax
            sub     rect.bottom, eax

            mov     ecx, Split2
            inc     ecx
            mov     edx, Split1[12]
            dec     edx
            mov     Split1[8], ecx
         INVOKE     MoveWindow, hWndChild1, 0, 0, ecx, edx, TRUE

            mov     ecx, Split2
            add     ecx, 2
            mov     Split3, ecx
            mov     edx, rect.right
            sub     edx, Split1[8]
            mov     esi, Split3[12]
            dec     esi
            mov     Split3[8], edx
            mov     Split2[12], esi
            dec     ecx
            mov     w2, edx
         INVOKE     MoveWindow, hWndChild2, ecx, 0, edx, esi, TRUE

            mov     edx, rect.bottom
            mov     ecx, Split1[12]
            mov     edi, ecx
            dec     edi
            sub     ecx, 2
            sub     edx, ecx
            mov     h3, edx
            mov     ecx, Split4
            inc     ecx
            inc     edx
         INVOKE     MoveWindow, hWndChild3, 0, edi, ecx, edx, TRUE

            mov     ecx, Split4
            add     ecx, 2
            mov     edx, rect.right
            sub     edx, Split4
            mov     eax, Split3[12]
            mov     edi, eax
            dec     edi
            mov     Split4[4], eax
            sub     eax, 2
            mov     esi, rect.bottom
            sub     esi, eax
            mov     Split4[12], esi
            dec     ecx
            dec     edx
            inc     esi
            mov     w4, edx
         INVOKE     MoveWindow, hWndChild4, ecx, edi, edx, esi, TRUE

            mov     ecx, Split1[12]
            dec     ecx
           push     ecx
         INVOKE     wsprintf, addr szOutW, addr fmat3, Split1[8]
            pop     ecx
         INVOKE     wsprintf, addr szOutH, addr fmat3, ecx
         INVOKE     lstrcpy, addr szOut, addr szOutW
         INVOKE     lstrcat, addr szOut, addr szX
         INVOKE     lstrcat, addr szOut, addr szOutH
         INVOKE     SendMessage, hWndChild1, WM_SETTEXT, 0, addr szOut

            dec     w2
         INVOKE     wsprintf, addr szOutW, addr fmat3, w2
         INVOKE     wsprintf, addr szOutH, addr fmat3, Split2[12]
         INVOKE     lstrcpy, addr szOut, addr szOutW
         INVOKE     lstrcat, addr szOut, addr szX
         INVOKE     lstrcat, addr szOut, addr szOutH
         INVOKE     SendMessage, hWndChild2, WM_SETTEXT, 0, addr szOut

            mov     ecx, Split4
            inc     ecx
         INVOKE     wsprintf, addr szOutW, addr fmat3, ecx
         INVOKE     wsprintf, addr szOutH, addr fmat3, h3
         INVOKE     lstrcpy, addr szOut, addr szOutW
         INVOKE     lstrcat, addr szOut, addr szX
         INVOKE     lstrcat, addr szOut, addr szOutH
         INVOKE     SendMessage, hWndChild3, WM_SETTEXT, 0, addr szOut

            dec     w4
         INVOKE     wsprintf, addr szOutW, addr fmat3, w4
         INVOKE     wsprintf, addr szOutH, addr fmat3, Split4[12]
         INVOKE     lstrcpy, addr szOut, addr szOutW
         INVOKE     lstrcat, addr szOut, addr szX
         INVOKE     lstrcat, addr szOut, addr szOutH
         INVOKE     SendMessage, hWndChild4, WM_SETTEXT, 0, addr szOut

      .elseif wMsg == WM_NOTIFY

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
         .if eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .endif

      .elseif wMsg == WM_MOUSEMOVE

;---------- [Capture the mouse if within an area] ----------
         INVOKE     GetClientRect, hWnd, addr rect
            mov     eax, lParam
            mov     edx, eax
            and     eax, 0ffffh   
            mov     xPos, eax
            shr     edx, 16
            mov     yPos, edx
         .if eax > Split1 && eax < Split1[8] && edx >= Split1[4] && edx <= Split1[12]
            INVOKE     LoadCursor, hInst, 899
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 1
         .elseif eax >= Split2 && eax <= Split2[8] && edx > Split2[4] && edx < Split2[12]
            INVOKE     LoadCursor, hInst, 898
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 2
         .elseif eax > Split3 && eax < rect.right && edx >= Split3[4] && edx <= Split3[12]
            INVOKE     LoadCursor, hInst, 899
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 3
         .elseif eax >= Split4 && eax <= Split4[8] && edx > Split4[4] && edx < rect.bottom
            INVOKE     LoadCursor, hInst, 898
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 4
         .else

;---------- [Release the mouse if out of the area] ----------
            .if wParam != MK_LBUTTON
                  xor     esi, esi
               .if BarType == 1
                     lea     esi, Split1
               .elseif BarType == 2
                     lea     esi, Split2
               .elseif BarType == 3
                     lea     esi, Split3
               .elseif BarType == 4
                     lea     esi, Split4
               .endif
               .if esi
                  .if eax < [esi] || eax > [esi+8] || edx < [esi+4] || edx > [esi+12]
                     INVOKE     ReleaseCapture
                  .endif
               .endif
            .endif
         .endif

         .if wParam == MK_LBUTTON
            INVOKE     GetClientRect, hWnd, addr rect
               mov     ecx, xPos
               mov     edx, yPos
               sub     rect.bottom, 28
            .if ecx > rect.left && ecx < rect.right && edx > rect.top && edx < rect.bottom
            .else
               INVOKE     LoadCursor, 0, IDC_ARROW
               INVOKE     SetCursor, eax
                  jmp     Ret0
            .endif

;---------- [Create and drag the Splitter bars] ----------
            .if BarType == 1 || BarType == 3     ; Horizontal
               INVOKE     LoadCursor, hInst, 899
               INVOKE     SetCursor, eax
               .if !hSplitBar
                  INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 0
               .endif
               .if BarType == 1
                     lea     edi, Split1
               .else
                     lea     edi, Split3
               .endif
                 push     edi
                  mov     eax, yPos
                  dec     eax
                  mov     [edi+4], eax
                  add     eax, 2
                  mov     [edi+12], ax
               INVOKE     GetWindowRect, hWnd, addr rect
                  pop     edi
                  add     rect.left, 6
                  mov     eax, rect.left
                  sub     rect.right, eax
                  add     eax, 8
                  add     eax, [edi+8]
               .if BarType == 3
                     mov     eax, [edi]
                     add     rect.left, eax
               .endif
                  mov     eax, rect.top
                  add     eax, 44
                  add     eax, [edi+4]
                  inc     eax
                  mov     rect.top, eax
                  mov     eax, Split2
               .if eax == Split4
                     mov     edx, [edi+8]
               .else
                     mov     edx, rect.right
                     sub     edx, 6
                  .if BarType == 1
                        lea     esi, Split3
                  .else
                        lea     esi, Split1
                     mov     eax, [edi]
                     sub     rect.left, eax
                  .endif
                     mov     eax, [edi+12]
                     mov     [esi+12], eax
                     mov     eax, [edi+4]
                     mov     [esi+4], eax
               .endif
               INVOKE     MoveWindow, hSplitBar, rect.left, rect.top, edx, 2, 1
            .endif

            .if BarType == 2 || BarType == 4       ; Vertical
               INVOKE     LoadCursor, hInst, 898
               INVOKE     SetCursor, eax
               .if !hSplitBar
                  INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 0
               .endif
               .if BarType == 2
                     lea     edi, Split2
               .else
                     lea     edi, Split4
               .endif
                 push     edi
                  mov     eax, xPos
                  dec     eax
                  mov     [edi], eax
                  add     eax, 2
                  mov     [edi+8], eax
               INVOKE     GetWindowRect, hWnd, addr rect
                  pop     edi
                  add     rect.top, 44
                  mov     eax, rect.top
                  add     eax, [edi+4]
                  sub     rect.bottom, eax
               .if BarType == 4
                     mov     eax, [edi+4]
                     add     rect.top, eax
               .endif
                  add     rect.left, 6
                  mov     eax, rect.left
                  add     eax, [edi]
                  inc     eax
                  mov     rect.left, eax
                  mov     eax, Split1[4]
               .if eax == Split3[4]
                     mov     edx, [edi+12]
               .else
                     mov     edx, rect.bottom
                     sub     edx, 28          ; Statusbar
                  .if BarType == 2
                        lea     esi, Split4
                  .else
                        lea     esi, Split2
                     mov     eax, [edi+4]
                     sub     rect.top, eax
                     add     edx, eax
                  .endif
                     mov     eax, [edi]
                     mov     [esi], eax
                     mov     eax, [edi+8]
                     mov     [esi+8], eax
               .endif
               INVOKE     MoveWindow, hSplitBar, rect.left, rect.top, 2, edx, 1
            .endif
         .endif

      .elseif wMsg == WM_LBUTTONUP

;---------- [Restore the cursor and call WM_SIZE] ----------
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
         INVOKE     ReleaseCapture
         INVOKE     SplitBarProc, hSplitBar, WM_COMMAND, IDCANCEL, 0
            and     hSplitBar, 0
            and     BarType, 0
         INVOKE     GetClientRect, hWnd, addr rect
            mov     edx, rect.bottom
            shl     edx, 16
            mov     ecx, rect.right
            mov     dx, cx
         INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx

      .elseif wMsg == WM_CLOSE
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc endp

;=========================================================================
; Splitter Bar PROCEDURE
;=========================================================================
SplitBarProc PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    hBrush:DWORD

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
         mov     eax, hdlg
         mov     hSplitBar, eax
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_CTLCOLORDLG
         je      ColorDlg
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
         je      CancleIt              ; and if not either of these
         jmp     DlgDone

ColorDlg:
      INVOKE     CreateSolidBrush, 000000ffh
         mov     hBrush, eax
         ret

CancleIt:
      INVOKE     DeleteObject, hBrush
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret                           ; Return
SplitBarProc ENDP

end start